#include "queue.h"
#include "configuration.h"

#include <stdio.h>
#include <stdlib.h>



/* Init a queue. */

void InitQueue(Queue *queue)
{
	queue->head = NULL;
}


/* Dispose the contents of the queue. */

void DeleteQueue(Queue *queue)
{
	if (queue->head)
	{
		DeleteCLContents(queue->head);
		free(queue->head);
	}
}


/* Add config to the queue.  */

void Enqueue(Queue *queue, struct Configuration *config)
{
static int inserts = 0;
	
	ConfigurationList *cl = NewConfigurationList(config, NULL);
	
	if (!queue->head)
		queue->head = queue->tail = cl;			/* it's empty */
	else
	{
		queue->tail->next = cl;		
		queue->tail = cl;
	}
	
	/* simple progress indicator */
	
	if (!(++inserts % 1000))
	{
		printf(".");
		fflush(stdout);
	}
}


/* Remove & return the head of the queue. */

struct Configuration *Dequeue(Queue *queue)
{
ConfigurationList *oldhead = queue->head;
Configuration *result = queue->head->config;

	queue->head = queue->head->next;
	
	free(oldhead);
		
	return result;
}


/* Is the queue empty? */

int	IsEmpty(Queue *queue)
{
	return !queue->head;
}


/* Is there a configuration in the queue matching a given configuration? */

int	IsInQueue(Queue *queue, struct Configuration *match)
{
	return queue->head && IsInCL(queue->head, match);
}
